'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = addCreationStack;
function addCreationStack(fn, what) {
  var createdAt = new Error(what + ' created at:');
  return function withCause() {
    try {
      return fn.apply(undefined, arguments);
    } catch (error) {
      if (!error.creationStack) error.creationStack = function () {
        return createdAt.stack;
      };
      throw error;
    }
  };
}