'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createMiddleware;

var _checkForNonFunctions = require('./checkForNonFunctions');

var _checkForNonFunctions2 = _interopRequireDefault(_checkForNonFunctions);

var _addCreationStack = require('./addCreationStack');

var _addCreationStack2 = _interopRequireDefault(_addCreationStack);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createMiddleware(actionHandlers) {
  if (process.env.NODE_ENV !== 'production') (0, _checkForNonFunctions2.default)(actionHandlers, 'actionHandlers');

  var result = function result(store) {
    return function (next) {
      var handleAction = function handleAction(action) {
        var handler = actionHandlers[action.type];
        if (!handler) return next(action);
        return handler(store)(next)(action);
      };
      if (process.env.NODE_ENV !== 'production') handleAction = (0, _addCreationStack2.default)(handleAction, 'middleware');
      return handleAction;
    };
  };
  result.actionHandlers = actionHandlers;
  return result;
}