'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createReducer;

var _lodash = require('lodash.size');

var _lodash2 = _interopRequireDefault(_lodash);

var _checkForNonFunctions = require('./checkForNonFunctions');

var _checkForNonFunctions2 = _interopRequireDefault(_checkForNonFunctions);

var _addCreationStack = require('./addCreationStack');

var _addCreationStack2 = _interopRequireDefault(_addCreationStack);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createReducer(initialState, actionHandlers) {
  if (arguments.length === 1) {
    actionHandlers = initialState;
    initialState = undefined;
  }

  if (process.env.NODE_ENV !== 'production') {
    (0, _checkForNonFunctions2.default)(actionHandlers, 'actionHandlers');
  }

  var result = void 0;
  if ((0, _lodash2.default)(actionHandlers)) {
    result = function result() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
      var action = arguments[1];

      var reducer = actionHandlers[action.type];
      return reducer ? reducer(state, action) : state;
    };
  } else {
    result = function result() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
      return state;
    };
  }
  if (process.env.NODE_ENV !== 'production') result = (0, _addCreationStack2.default)(result, 'reducer');
  result.initialState = initialState;
  result.actionHandlers = actionHandlers;
  return result;
}