var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import mapKeys from 'lodash.mapkeys';
import createReducer from './createReducer';
import addCreationStack from './addCreationStack';

export default function prefixReducer(prefix) {
  return reducer => {
    if (reducer.actionHandlers instanceof Object) {
      return createReducer(reducer.initialState, mapKeys(reducer.actionHandlers, (handler, key) => prefix + key));
    }
    let result = (state, action) => typeof action.type === 'string' && action.type.startsWith(prefix) ? reducer(state, _extends({}, action, { type: action.type.substring(prefix.length) })) : state;

    if (process.env.NODE_ENV !== 'production') result = addCreationStack(result, 'reducer');
    return result;
  };
}